#include "stdafx.h"
#include "Demon.h"


Demon::Demon(int posX, int posY)
{
	sheetOrgin.x = 0;
	sheetOrgin.y = 0;
	sheetOrgin.w = 77;
	sheetOrgin.h = 88;

	screenOutput.x = posX;
	screenOutput.y = posY;
	screenOutput.w = 77;
	screenOutput.h = 88;
}

// Get sheetOrigin
SDL_Rect Demon::SheetOrigin() {
	return sheetOrgin;
}

// Get character position
SDL_Rect Demon::CharPos() {
	return screenOutput;
}

// Reset Character
void Demon::Reset(int posX, int posY) {
	screenOutput.x = posX;
	screenOutput.y = posY;
	moving = 'S';
	sheetOrgin.x = 0;
	sheetOrgin.y = 0;
}

void Demon::Update(int playerX, int playerY) {

	// remove negative distances
	int distanceXSqr = (playerX - screenOutput.x)*(playerX - screenOutput.x);
	int distanceYSqr = (playerY - screenOutput.y)*(playerY - screenOutput.y);

	// Is player further in the X direction?
	if (distanceXSqr > distanceYSqr) {
		
		// Is player West?
		if (playerX - screenOutput.x < 0) {
			moving = 'W';
			sheetOrgin.x = (1 * 77);
			screenOutput.x -= 2;
		}
		else {
			moving = 'E';
			sheetOrgin.x = (2 * 77);
			screenOutput.x += 2;
		}
	}
	else {
		// Is player North?
		if (playerY - screenOutput.y < 0) {
			moving = 'N';
			sheetOrgin.x = (3 * 77);
			screenOutput.y -= 2;
		}
		else {
			moving = 'S';
			sheetOrgin.x = (0 * 77);
			screenOutput.y += 2;
		}
	}

		
}

Demon::~Demon()
{
}
