// SacrificialSacrament.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>

// include sdl
#include <SDL.h>
#include <SDL_image.h>
#undef main

// include character classes
#include "Student.h"
#include "Demon.h"

// create sdl window objects
SDL_Window* window = NULL;
SDL_Renderer* renderer = NULL;
SDL_Surface* surface = NULL;

// screen dimensions
const int screenH = 960;
const int screenV = 720;

// Initialise SDL
bool InitSDL();

// Texture Variables
enum Backgrounds {
	title,
	gameOver,
	Victory,
	cutScenes,
	roomOne,
	roomTwo,
	roomthree,
	TOTAL
};

enum Buttons {
	PlayUn,
	Play,
	total
};

SDL_Texture* Backgrounds[TOTAL];
SDL_Texture* currentBackground = NULL;

SDL_Texture* Buttons[total];

// Room One Sprites
SDL_Texture* skeleton = NULL;
SDL_Rect skeletonRect;

SDL_Texture* cutscene1[11];
SDL_Rect cutsceneLoc;

// Demon
Demon demon(780, 275);
SDL_Texture* demonText = NULL;


void CutsceneOne() {
	for (int i = 0; i < 7; i++) {
		SDL_RenderCopy(renderer, Backgrounds[cutScenes], NULL, NULL);
		SDL_RenderCopy(renderer, cutscene1[i], NULL, &cutsceneLoc);
		SDL_RenderPresent(renderer);
		SDL_Delay(5000);
	}
	for (int i = 7; i < 11; i++) {
		SDL_RenderCopy(renderer, Backgrounds[roomOne], NULL, NULL);
		SDL_RenderCopy(renderer, cutscene1[i], NULL, &cutsceneLoc);
		SDL_RenderPresent(renderer);
		SDL_Delay(5000);
	}
}



// Room Two
int secinframes = 60;
int Time = 10;
SDL_Texture* statue;
SDL_Rect statueRect;
enum PuzzlePieces {
	HammerHead,
	BrokenPlank,
	Key,
	door,
	time,
	Bsub,
	Hsub,
	Hammersub
};
SDL_Texture* PuzzlePieces[8];
SDL_Rect HammerHeadPos;
SDL_Rect BrokenPlankPos;
SDL_Rect KeyPos;
SDL_Rect timePos;
SDL_Rect SubLoc;
bool lockedR2 = true;
bool HammerHeadR2 = false;
bool BrokenPlankR2 = false;
bool keyR2 = false;
int SubHammer = 0;
int SubH = 0;
int SubB = 0;

// Room Three
SDL_Texture* Exit;
SDL_Rect ExitPos;

// Play Button
SDL_Texture* playButton = NULL;
SDL_Rect playButtonPos;

// cursor
SDL_Texture* cursor;
SDL_Rect cursorPos;

// character sheets
SDL_Texture* playersheet = NULL;
SDL_Texture* health = NULL;

// load textures
void LoadTextures();
SDL_Surface* LoadImage(std::string filename);

// Game Loop Variables
bool running = true;
Uint32 timer;

// Game Loop Functions
void UserInput();
void GameLogic();
void Render();
void ResetGame();

// Game Variables
char room = '1';
Student player(50, 50);

// Clues
enum Clues {
	Letter,
	Tablet,
	Blood
};
bool LetterClue = false;
bool TabletClue = false;
bool BloodClue = false;
SDL_Texture* Clues[3];
SDL_Rect letterCLuePos;
SDL_Rect TabletCluePos; 
SDL_Rect BloodPos;


void PrepareRoomOne() {

	// skeleton position
	skeletonRect.x = 796;
	skeletonRect.y = 20;
	skeletonRect.w = 144;
	skeletonRect.h = 144;

	// cutsceneLoc
	cutsceneLoc.x = 230;
	cutsceneLoc.y = 220;
	cutsceneLoc.w = 500;
	cutsceneLoc.h = 500;

	// letter clue
	letterCLuePos.x = 350;
	letterCLuePos.y = 180;
	letterCLuePos.w = 260;
	letterCLuePos.h = 360;

}
void PrepareRoomTwo() {
	// statue position
	statueRect.x = 796;
	statueRect.y = 20;
	statueRect.w = 144;
	statueRect.h = 256;

	// HammerHead position
	HammerHeadPos.x = 750;
	HammerHeadPos.y = 600;
	HammerHeadPos.w = 50;
	HammerHeadPos.h = 25;

	//  position
	BrokenPlankPos.x = 250;
	BrokenPlankPos.y = 200;
	BrokenPlankPos.w = 55;
	BrokenPlankPos.h = 125;

	// key position
	KeyPos.x = 350;
	KeyPos.y = 20;
	KeyPos.w = 260;
	KeyPos.h = 120;

	// key position
	timePos.x = 5;
	timePos.y = 700;
	timePos.w = 20;
	timePos.h = 20;

	SubLoc.x = 230;
	SubLoc.y = 600;
	SubLoc.w = 500;
	SubLoc.h = 100;

	TabletCluePos.x = 150;
	TabletCluePos.y = 600;
	TabletCluePos.w = 24;//235;
	TabletCluePos.h = 27;//275;


}
void PrepareRoomThree() {
	// exit position
	ExitPos.x = 430;
	ExitPos.y = 310;
	ExitPos.w = 100;
	ExitPos.h = 100;

	// Blood position
	BloodPos.x = 840;
	BloodPos.y = 600;
	BloodPos.w = 100;
	BloodPos.h = 100;

}

SDL_Texture* Cutscene2[2];

void CutsceneTwo() {
	for (int i = 0; i < 2; i++) {
		SDL_RenderCopy(renderer, Backgrounds[roomTwo], NULL, NULL);
		SDL_RenderCopy(renderer, statue, NULL, &statueRect);
		SDL_RenderCopy(renderer, Clues[Tablet], NULL, &TabletCluePos);
		if (lockedR2) {
			SDL_RenderCopy(renderer, PuzzlePieces[door], NULL, NULL);
			for (int i = 0; i < Time; i++) {
				timePos.x = 5 + (20 * i);
				SDL_RenderCopy(renderer, PuzzlePieces[time], NULL, &timePos);
			}
		}
		if (!keyR2)
			SDL_RenderCopy(renderer, PuzzlePieces[Key], NULL, &KeyPos);
		if (!BrokenPlankR2)
			SDL_RenderCopy(renderer, PuzzlePieces[BrokenPlank], NULL, &BrokenPlankPos);
		if (!HammerHeadR2)
			SDL_RenderCopy(renderer, PuzzlePieces[HammerHead], NULL, &HammerHeadPos);
		SDL_RenderCopy(renderer, Cutscene2[i], NULL, &cutsceneLoc);
		SDL_RenderPresent(renderer);
		SDL_Delay(6000);
	}
}

SDL_Texture* Cutscene3[2];
void CutsceneThree() {
	for (int i = 0; i < 2; i++) {
		SDL_RenderCopy(renderer, Backgrounds[roomthree], NULL, NULL);
		SDL_RenderCopy(renderer, Exit, NULL, &ExitPos);
		SDL_RenderCopy(renderer, Clues[Blood], NULL, &BloodPos);
		SDL_RenderCopy(renderer, Cutscene3[i], NULL, &cutsceneLoc);
		SDL_RenderPresent(renderer);
		SDL_Delay(4000);
	}
}

int main()
{
	// Init SDL
	bool functionalSDL = InitSDL();
	if (functionalSDL == false) {
		std::cout << "Failed Initialisation of SDL" << std::endl;
	}
	// run game if sdl is functional
	else {
		// load textures
		LoadTextures();

		// Menu Stuff
		playButtonPos.x = 280;
		playButtonPos.y = 120;
		playButtonPos.w = 400;
		playButtonPos.h = 100;

		// cursor
		cursorPos.x = 0;
		cursorPos.y = 0;
		cursorPos.w = 45;
		cursorPos.h = 45;

		// Rooms
		PrepareRoomOne();
		PrepareRoomTwo();
		PrepareRoomThree();

		// begin game loop
		while (running) {
			const int fps = 60;
			timer = SDL_GetTicks();

			// Get User Input
			UserInput();

			// Game Logic
			GameLogic();

			// Render
			Render();
			if (1000 / fps > SDL_GetTicks()-timer)
				SDL_Delay((1000 / fps) - (SDL_GetTicks() - timer));

		}

		// Exit SDL
		SDL_DestroyWindow(window);
		SDL_Quit();
	}
    return 0;
}

bool InitSDL() {
	// initialise SDL
	if (SDL_Init(SDL_INIT_VIDEO) < 0) {
		// print error message
		std::cout << "SDL WINDOW INIT ERROR: " << SDL_GetError() << std::endl;
		return false;
	}
	// define window
	else {
		window = SDL_CreateWindow(
			"Sacrificial Sacrament",			// title
			SDL_WINDOWPOS_CENTERED,
			SDL_WINDOWPOS_CENTERED,
			screenH,							// Width
			screenV,							// Height
			SDL_WINDOW_SHOWN);
		renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);

		// check window successful
		if (window == NULL) {
			std::cout << "SDL WINDOW ASSIGNMENT ERROR: " << SDL_GetError() << std::endl;
			return false;
		}
		else {
			// Initialise SDL image
			int imgFlags = IMG_INIT_PNG;
			if (!(IMG_Init(imgFlags) & imgFlags)) {
				std::cout << "SDL IMAGE ERROR: " << IMG_GetError() << std::endl;
			}
			else {

				// clear screen
				surface = SDL_GetWindowSurface(window);

				// render current background
				SDL_FillRect(surface, NULL, SDL_MapRGB(surface->format, 0xFF, 0xFF, 0xFF));

				// update screen
				SDL_UpdateWindowSurface(window);
			}
		}
	}
	SDL_ShowCursor(0);
	return true;
}

void UserInput() {
	// create event object
	SDL_Event e;
	
	// get event from queue
	while (SDL_PollEvent(&e)) {

		// check for quit
		if (e.type == SDL_QUIT) {
			running = false;
		}

		// Get KeyDown information
		if (e.type == SDL_KEYDOWN) {
			switch (e.key.keysym.sym) {
				
				// check for ESC key to quit
				case SDLK_ESCAPE:
					running = false;
					break;

				// player movement
				case SDLK_w: player.Move('N',false); break;
				case SDLK_d: player.Move('E', false); break;
				case SDLK_s: player.Move('S', false); break;
				case SDLK_a: player.Move('W', false); break;
			}
		}
		if (e.type == SDL_KEYUP) {
			switch (e.key.keysym.sym) {

				// player movement
				case SDLK_w: player.Move('N',true); break;
				case SDLK_d: player.Move('E', true); break;
				case SDLK_s: player.Move('S', true); break;
				case SDLK_a: player.Move('W', true); break;

			}
		}
		if (e.type == SDL_MOUSEBUTTONDOWN) {
			if (e.button.button == SDL_BUTTON_LEFT) {
				int x;
				int y;
				SDL_GetMouseState(&x, &y);
				std::cout << x << " " << y << std::endl;
				if (x > 280 && x < 680 && room == 'M') {
					if (y > 120 && y < 220) {
						playButton = Buttons[Play];
					}
				}
			}
		}
		if (e.type == SDL_MOUSEBUTTONUP) {
			if (e.button.button == SDL_BUTTON_LEFT) {
				int x;
				int y;
				SDL_GetMouseState(&x, &y);
				if (x > 280 && x < 680 && room == 'M') {
					if (y > 120 && y < 220) {
						playButton = Buttons[PlayUn];
						std::cout << "UP" << std::endl;
						CutsceneOne();
						room = '1';
					}
				}
			}
		}
	}

}

/* CURRENTLY NOT IN USE

SDL_Surface* LoadImage(std::string filename) {

	// SDL image surface
	SDL_Surface* initialLoad = NULL;

	// SDL surface
	SDL_Surface* loaded = NULL;

	// Load image
	initialLoad = IMG_Load(filename.c_str());

	// ensure initial load was successful
	if (initialLoad == NULL) {
		std::cout << "Image failed to load - " << filename.c_str() << " - IMG ERROR: " << IMG_GetError() << std::endl;
	}
	else {
		// convert to usable format
		loaded = SDL_ConvertSurface(initialLoad, surface->format, NULL);
		if(loaded == NULL)
			std::cout << "Image failed to convert - " << filename.c_str() << " - IMG ERROR: " << SDL_GetError() << std::endl;
	}
	SDL_FreeSurface(initialLoad);
	return loaded;
}*/


void LoadTextures() {
	// Load Backgrounds
	Backgrounds[title] = IMG_LoadTexture(renderer, "Images/TitleCard.png"); // "Images/TitleCard.png"));
	if (Backgrounds[title] == NULL)
		std::cout << "title Failed to Load!" << std::endl;
	currentBackground = Backgrounds[title];

	Backgrounds[cutScenes] = IMG_LoadTexture(renderer, "Images/Cutscenes.png"); // "Images/TitleCard.png"));
	if (Backgrounds[title] == NULL)
		std::cout << "title Failed to Load!" << std::endl;

	Backgrounds[Victory] = IMG_LoadTexture(renderer, "Images/Victory.png"); // "Images/TitleCard.png"));
	if (Backgrounds[Victory] == NULL)
		std::cout << "Victory Failed to Load!" << std::endl;

	Backgrounds[roomOne] = IMG_LoadTexture(renderer, "Images/RoomOne.png"); // "Images/RoomOne.png"));
	if (Backgrounds[roomOne] == NULL)
		std::cout << "roomOne Failed to Load!" << std::endl;

	Backgrounds[roomTwo] = IMG_LoadTexture(renderer, "Images/RoomTwo.png"); // "Images/RoomTwo.png"));
	if (Backgrounds[roomTwo] == NULL)
		std::cout << "roomTwo Failed to Load!" << std::endl;

	Backgrounds[gameOver] = IMG_LoadTexture(renderer, "Images/GameOver.png"); // "Images/RoomOne.png"));
	if (Backgrounds[gameOver] == NULL)
		std::cout << "gameOver Failed to Load!" << std::endl;


	// load character textures
	playersheet = IMG_LoadTexture(renderer, "Images/GoodGuys/PlayerSheet.png"); //SDL_CreateTextureFromSurface(renderer,LoadImage("Images/GoodGuys/tmpWalkOne.png"));
	if (playersheet == NULL)
		std::cout << "player sheet error!!!" << std::endl;

	health = IMG_LoadTexture(renderer, "Images/Health.png"); //SDL_CreateTextureFromSurface(renderer,LoadImage("Images/GoodGuys/tmpWalkOne.png"));
	if (health == NULL)
		std::cout << "health sheet error!!!" << std::endl;

	// Load Menu Items
	Buttons[PlayUn] = IMG_LoadTexture(renderer, "Images/Buttons/PlayUnpressed.png"); //SDL_CreateTextureFromSurface(renderer, LoadImage("Images/Buttons/PlayUnpressed.png"));
	if (Backgrounds[PlayUn] == NULL)
		std::cout << "PlayUn Failed to Load!" << std::endl;

	Buttons[Play] = IMG_LoadTexture(renderer,"Images/Buttons/PlayPressed.png"); //SDL_CreateTextureFromSurface(renderer, LoadImage("Images/Buttons/PlayPressed.png"));
	if (Backgrounds[Play] == NULL)
		std::cout << "Play Failed to Load!" << std::endl;

	cursor = IMG_LoadTexture(renderer, "Images/Cursor.png");
	if (cursor == NULL)
		std::cout << "cursor failed to load!" << std::endl;
	playButton = Buttons[PlayUn];

	// Load Room One Stuff
	skeleton = IMG_LoadTexture(renderer, "Images/Skeleton.png");
	if (skeleton == NULL)
		std::cout << "skeleton failed to load!" << std::endl;

	Clues[Letter] = IMG_LoadTexture(renderer, "Images/LetterCLue.png");
	if (Clues[Letter] == NULL)
		std::cout << "Clues[Letter] failed to load!" << std::endl;

	// Demon
	demonText = IMG_LoadTexture(renderer, "Images/Demon.png");
	if (demonText == NULL)
		std::cout << "demonText failed to load!" << std::endl;
	
	// Load Cutscene 1
	cutscene1[0] = IMG_LoadTexture(renderer, "Images/Cutscene1/1.png");
	if (cutscene1[0] == NULL)
		std::cout << "cutscene1[0] failed to load!" << std::endl;
	cutscene1[1] = IMG_LoadTexture(renderer, "Images/Cutscene1/2.png");
	if (cutscene1[1] == NULL)
		std::cout << "cutscene1[1] failed to load!" << std::endl;
	cutscene1[2] = IMG_LoadTexture(renderer, "Images/Cutscene1/3.png");
	if (cutscene1[2] == NULL)
		std::cout << "cutscene1[2] failed to load!" << std::endl;
	cutscene1[3] = IMG_LoadTexture(renderer, "Images/Cutscene1/4.png");
	if (cutscene1[3] == NULL)
		std::cout << "cutscene1[3] failed to load!" << std::endl;
	cutscene1[4] = IMG_LoadTexture(renderer, "Images/Cutscene1/5.png");
	if (cutscene1[4] == NULL)
		std::cout << "cutscene1[4] failed to load!" << std::endl;
	cutscene1[5] = IMG_LoadTexture(renderer, "Images/Cutscene1/6.png");
	if (cutscene1[5] == NULL)
		std::cout << "cutscene1[5] failed to load!" << std::endl;
	cutscene1[6] = IMG_LoadTexture(renderer, "Images/Cutscene1/7.png");
	if (cutscene1[6] == NULL)
		std::cout << "cutscene1[6] failed to load!" << std::endl;
	cutscene1[7] = IMG_LoadTexture(renderer, "Images/Cutscene1/8.png");
	if (cutscene1[7] == NULL)
		std::cout << "cutscene1[7] failed to load!" << std::endl;
	cutscene1[8] = IMG_LoadTexture(renderer, "Images/Cutscene1/9.png");
	if (cutscene1[8] == NULL)
		std::cout << "cutscene1[8] failed to load!" << std::endl;
	cutscene1[9] = IMG_LoadTexture(renderer, "Images/Cutscene1/10.png");
	if (cutscene1[9] == NULL)
		std::cout << "cutscene1[9] failed to load!" << std::endl;
	cutscene1[10] = IMG_LoadTexture(renderer, "Images/Cutscene1/11.png");
	if (cutscene1[10] == NULL)
		std::cout << "cutscene1[20] failed to load!" << std::endl;


	// load Cutscene2
	Cutscene2[0] = IMG_LoadTexture(renderer, "Images/Cutscene2/1.png");
	if (Cutscene2[0] == NULL)
		std::cout << "Cutscene2[0] failed to load!" << std::endl;
	Cutscene2[1] = IMG_LoadTexture(renderer, "Images/Cutscene2/2.png");
	if (Cutscene2[1] == NULL)
		std::cout << "Cutscene2[1] failed to load!" << std::endl;

	// load Cutscene3
	Cutscene3[0] = IMG_LoadTexture(renderer, "Images/Cutscene3/1.png");
	if (Cutscene3[0] == NULL)
		std::cout << "Cutscene3[0] failed to load!" << std::endl;
	Cutscene3[1] = IMG_LoadTexture(renderer, "Images/Cutscene3/2.png");
	if (Cutscene3[1] == NULL)
		std::cout << "Cutscene3[1] failed to load!" << std::endl;

	// Room 2
	statue = IMG_LoadTexture(renderer, "Images/Statue.png");
	if (statue == NULL)
		std::cout << "statue failed to load!" << std::endl;

	PuzzlePieces[Key] = IMG_LoadTexture(renderer, "Images/key.png");
	if (PuzzlePieces[Key] == NULL)
		std::cout << "PuzzlePieces[Key] failed to load!" << std::endl;

	PuzzlePieces[door] = IMG_LoadTexture(renderer, "Images/Room2Lock.png");
	if (PuzzlePieces[door] == NULL)
		std::cout << "PuzzlePieces[door] failed to load!" << std::endl;

	PuzzlePieces[HammerHead] = IMG_LoadTexture(renderer, "Images/HammerHead.png");
	if (PuzzlePieces[HammerHead] == NULL)
		std::cout << "PuzzlePieces[HammerHead] failed to load!" << std::endl;

	PuzzlePieces[BrokenPlank] = IMG_LoadTexture(renderer, "Images/BrokenBoard.png");
	if (PuzzlePieces[BrokenPlank] == NULL)
		std::cout << "PuzzlePieces[BrokenPlank] failed to load!" << std::endl;

	PuzzlePieces[time] = IMG_LoadTexture(renderer, "Images/TIME.png");
	if (PuzzlePieces[time] == NULL)
		std::cout << "PuzzlePieces[time] failed to load!" << std::endl;

	PuzzlePieces[Bsub] = IMG_LoadTexture(renderer, "Images/Bsub.png");
	if (PuzzlePieces[Bsub] == NULL)
		std::cout << "PuzzlePieces[Bsub] failed to load!" << std::endl;

	PuzzlePieces[Hsub] = IMG_LoadTexture(renderer, "Images/Hsub.png");
	if (PuzzlePieces[Hsub] == NULL)
		std::cout << "PuzzlePieces[Hsub] failed to load!" << std::endl;

	PuzzlePieces[Hammersub] = IMG_LoadTexture(renderer, "Images/Hammersub.png");
	if (PuzzlePieces[Hammersub] == NULL)
		std::cout << "PuzzlePieces[Hammersub] failed to load!" << std::endl;

	Clues[Tablet] = IMG_LoadTexture(renderer, "Images/TabletClue.png");
	if (Clues[Tablet] == NULL)
		std::cout << "Clues[Tablet] failed to load!" << std::endl;

	// Room Three
	Backgrounds[roomthree] = IMG_LoadTexture(renderer, "Images/RoomThree.png");
	if (Backgrounds[roomthree] == NULL)
		std::cout << "Backgrounds[roomthree] failed to load!" << std::endl;

	Exit = IMG_LoadTexture(renderer, "Images/Exit.png");
	if (Exit == NULL)
		std::cout << "Exit failed to load!" << std::endl;

	Clues[Blood] = IMG_LoadTexture(renderer, "Images/Clue3.png");
	if (Clues[Blood] == NULL)
		std::cout << "Clues[Blood] failed to load!" << std::endl;
}

void GameLogic() {

	if (room != 'M') {
		player.Update(room);
		if (player.GetHealth() < 1) {
			room = 'G';
		}
		switch (room) {
		case '1':
			demon.Update(player.GetPos('x'), player.GetPos('y'));
			player.DemonCol(demon.CharPos().x, demon.CharPos().y, demon.CharPos().w, demon.CharPos().h,false);
			if (player.GetPos('x') + 96 > 960) {
				room = '2';
				if (lockedR2)
					CutsceneTwo();
				player.SetPos(50, 275);
			}
			// skeleton LetterClue
			if (player.Collided(skeletonRect.x, skeletonRect.y, skeletonRect.w, skeletonRect.h) && !LetterClue) {
				std::cout << "Letter Clue Found!" << std::endl;
				SDL_RenderCopy(renderer, Clues[Letter], NULL, &letterCLuePos);
				SDL_RenderPresent(renderer);
				SDL_Delay(7000);
				LetterClue = true;
			}
			break;
		case '2':
			if (player.GetPos('x') < 0 && !lockedR2) {
				room = '1';
				demon.Reset(480, 275);
				player.SetPos(960-96, 275);
			}
			if (player.GetPos('x') + 96 > 960) {
				room = '3';
				CutsceneThree();
				demon.Reset(480, 275);
				player.SetPos(50, 275);
			}
			// tablet LetterClue
			if (player.Collided(TabletCluePos.x, TabletCluePos.y, TabletCluePos.w, TabletCluePos.h) && !TabletClue) {
				std::cout << "Tablet Clue Found!" << std::endl;
				SDL_Rect TabletCluePos1;
				TabletCluePos1.x = 362;
				TabletCluePos1.y = 222;
				TabletCluePos1.w = 235;
				TabletCluePos1.h = 275;
				SDL_RenderCopy(renderer, Clues[Tablet], NULL, &TabletCluePos1);
				SDL_RenderPresent(renderer);
				SDL_Delay(5000);
				TabletClue = true;
			}
			if (lockedR2) {
				secinframes--;
				if (secinframes <= 0) {
					secinframes = 60;
					Time--;
				}
				if (Time <= 0)
					room = 'G';

				if (player.GetPos('x') > 960 - 96 - 20)
					player.SetPos(960 - 96 - 20,player.GetPos('y'));
				if (player.GetPos('x') < 20)
					player.SetPos(20,player.GetPos('y'));
			}
			// collect plank
			if (player.Collided(BrokenPlankPos.x, BrokenPlankPos.y, BrokenPlankPos.w, BrokenPlankPos.h) && !BrokenPlankR2) {
				BrokenPlankR2 = true;
				SubB = 60;
				if (HammerHeadR2)
					SubHammer = 60;
			}
			// collect hammer head
			if (player.Collided(HammerHeadPos.x, HammerHeadPos.y, HammerHeadPos.w, HammerHeadPos.h) && !HammerHeadR2) {
				HammerHeadR2 = true;
				SubH = 60;
				if(BrokenPlankR2)
					SubHammer = 60;
			}
			// collect hammer head
			if (player.Collided(KeyPos.x, KeyPos.y, KeyPos.w, KeyPos.h) && !keyR2 && HammerHeadR2 && BrokenPlankR2) {
				keyR2 = true;
				lockedR2 = false;
			}
			break;
		case '3':
			if (player.GetPos('x') < 0) {
				room = '2';
				player.SetPos(960 - 96, 275);
			}
			demon.Update(player.GetPos('x'), player.GetPos('y'));
			player.DemonCol(demon.CharPos().x, demon.CharPos().y, demon.CharPos().w, demon.CharPos().h,true);
			// Escape
			if (player.Collided(ExitPos.x, ExitPos.y, ExitPos.w, ExitPos.h) && room == '3') {
				room = 'V';
			}
			// Blood Clue
			if (player.Collided(BloodPos.x, BloodPos.y, BloodPos.w, BloodPos.h) && !BloodClue) {
				std::cout << "Tablet Clue Found!" << std::endl;
				SDL_Rect TabletCluePos1;
				TabletCluePos1.x = 230;
				TabletCluePos1.y = 110;
				TabletCluePos1.w = 500;
				TabletCluePos1.h = 500;
				SDL_RenderCopy(renderer, Clues[Blood], NULL, &TabletCluePos1);
				SDL_RenderPresent(renderer);
				SDL_Delay(14000);
				BloodClue = true;
			}
			break;
		}
	}
	// Menu specific Logic
	else {
		// update cursor position
		int x = 0;
		int y = 0;
		SDL_GetMouseState(&x, &y);
		cursorPos.x = x;
		cursorPos.y = y;
	}
}

void Render() {
	// fill screen black
	// SDL_FillRect(surface, NULL, SDL_MapRGB(surface->format, 0x00, 0x00, 0x00));

	// render background
	switch (room) {
		case 'M':SDL_RenderCopy(renderer, Backgrounds[title], NULL, NULL); break;
		case '1':
			SDL_RenderCopy(renderer, Backgrounds[roomOne], NULL, NULL);
			SDL_RenderCopy(renderer, skeleton, NULL, &skeletonRect);
			SDL_RenderCopy(renderer, demonText, &demon.SheetOrigin(), &demon.CharPos());
			break;
		case '2':
			SDL_RenderCopy(renderer, Backgrounds[roomTwo], NULL, NULL);
			SDL_RenderCopy(renderer, statue, NULL, &statueRect);
			SDL_RenderCopy(renderer, Clues[Tablet], NULL, &TabletCluePos);
			if (lockedR2) {
				SDL_RenderCopy(renderer, PuzzlePieces[door], NULL, NULL);
				for (int i = 0; i < Time; i++) {
					timePos.x = 5 + (20*i);
					SDL_RenderCopy(renderer, PuzzlePieces[time], NULL, &timePos);
				}
			}
			if(!keyR2)
				SDL_RenderCopy(renderer, PuzzlePieces[Key], NULL, &KeyPos);
			if (!BrokenPlankR2)
				SDL_RenderCopy(renderer, PuzzlePieces[BrokenPlank], NULL, &BrokenPlankPos);
			if (!HammerHeadR2)
				SDL_RenderCopy(renderer, PuzzlePieces[HammerHead], NULL, &HammerHeadPos);
			if (SubB > 0 && SubHammer == 0) {
				SubB--;
				SDL_RenderCopy(renderer, PuzzlePieces[Hsub], NULL, &SubLoc);
			}
			if (SubH > 0 && SubHammer == 0) {
				SubH--;
				SDL_RenderCopy(renderer, PuzzlePieces[Bsub], NULL, &SubLoc);
			}
			if (SubHammer > 0) {
				SubHammer--;
				SubB = 0;
				SubH = 0;
				SDL_RenderCopy(renderer, PuzzlePieces[Hammersub], NULL, &SubLoc);
			}
			break;
		case '3':
			SDL_RenderCopy(renderer, Backgrounds[roomthree], NULL, NULL);
			SDL_RenderCopy(renderer, Exit, NULL, &ExitPos);
			SDL_RenderCopy(renderer, Clues[Blood], NULL, &BloodPos);
			SDL_RenderCopy(renderer, demonText, &demon.SheetOrigin(), &demon.CharPos());


	}
	// don't render game obects whilst in menu
	if(room != 'M' && room != 'G' && room != 'V') {
		// render characters
		SDL_RenderCopy(renderer, playersheet, &player.SheetOrigin(), &player.CharPos());
		for (int i = 0; i < player.GetHealth(); i++) {
			SDL_Rect tmp;
			tmp.x = 5 + (i * 25);
			tmp.y = 0;
			tmp.w = 23;
			tmp.h = 23;

			SDL_RenderCopy(renderer, health, NULL, &tmp);
		}
	}
	else {
		if (room == 'G') {
			SDL_RenderCopy(renderer, Backgrounds[gameOver], NULL, NULL);
			SDL_RenderPresent(renderer);
			SDL_Delay(2000);
			ResetGame();
			room = 'M';
		}
		if (room == 'V') {
			SDL_RenderCopy(renderer, Backgrounds[Victory], NULL, NULL);
			SDL_RenderPresent(renderer);
			SDL_Delay(4000);
			ResetGame();
			room = 'M';
		}
		SDL_RenderCopy(renderer, playButton, NULL, &playButtonPos);
		SDL_RenderCopy(renderer, cursor, NULL, &cursorPos);
	}
	SDL_RenderPresent(renderer);
	// update screen
	// SDL_UpdateWindowSurface(window);
}

void ResetGame() {
	// reset characters
	player.Reset(50, 50);
	demon.Reset(780, 275);
	LetterClue = false;
	TabletClue = false;
	 lockedR2 = true;
	 HammerHeadR2 = false;
	 BrokenPlankR2 = false;
	 keyR2 = false;
	 secinframes = 60;
	 Time = 10;
	 BloodClue = false;
	 SubHammer = 0;
	 SubH = 0;
	 SubB = 0;
}