#include "stdafx.h"
#include "Student.h"

Student::Student(int posX, int posY)
{
	// Starting location of the character sprite on spritesheet
	sheetOrgin.x = 0;
	sheetOrgin.y = 0;
	sheetOrgin.w = 96;
	sheetOrgin.h = 144;

	// Location of sprite in game
	screenOutput.x = posX;
	screenOutput.y = posY;
	screenOutput.w = 96;
	screenOutput.h = 144;

	// Health
	health = 10;
}

int Student::GetHealth() {
	return health;
}

void Student::Reset(int posX, int posY) {
	screenOutput.x = posX;
	screenOutput.y = posY;
	health = 10;
	moving = '-';
	immune = 0;
	spriteCount = 0;
}

void Student::SetPos(int posX, int posY) {
	screenOutput.x = posX;
	screenOutput.y = posY;
}

// Get sheetOrigin
SDL_Rect Student::SheetOrigin() {
	return sheetOrgin;
}

// Get character position
SDL_Rect Student::CharPos() {
	return screenOutput;
}

int Student::GetPos(char a) {
	int value;
	switch (a) {
		case 'x':
			value = screenOutput.x;
			break;
		case 'y':
			value = screenOutput.y;
			break;
		default:
			value = 0;
			break;
	}
	return value;
}

void Student::DemonCol(int DemonX, int DemonY, int DemonW, int DemonH,bool insta) {
	bool col = Collided(DemonX, DemonY, DemonW, DemonH);
	if (col && immune == 0) {
		health -= 1;
		immune = 60;
		std::cout << "Health: " << health << std::endl;
	}
	if (col && insta)
		health = 0;
}

// dectect box collisions
bool Student::Collided(int objX, int objY, int objW, int objH) {

	// within x axis?
	if (objX  > screenOutput.x - objW && objX < screenOutput.x + 96) {
		// within y axis?
		if(objY > screenOutput.y - objH && objY < screenOutput.y + 144) {
			return true;
		}
	}
	return false;
}

void Student::Move(char d, bool lift) {
	if (!lift) {
		moving = d;
	}
	else {
		if (moving == d) {
			moving = '-';
		}
	}
}

void Student::WallDetection(bool north, bool east, bool south, bool west) {

	if (east) {
		// Allow walking through doorway in east wall
		if ((screenOutput.x > 960 - 96 - 20) && (screenOutput.y < 265 || screenOutput.y > 440 - 144))
			screenOutput.x = 960 - 96 - 20;
	}
	else {
		if (screenOutput.x > 960 - 96 - 20)
			screenOutput.x = 960 - 96 - 20;
	}

	if (west) {
		// Allow walking through doorway in east wall
		if ((screenOutput.x < 20) && (screenOutput.y < 265 || screenOutput.y > 440 - 144))
			screenOutput.x = 20;
	}
	else {
		if (screenOutput.x < 20)
			screenOutput.x = 20;
	}

	if (screenOutput.y < 20)
		screenOutput.y = 20;
	if (screenOutput.y > 720 - 144 - 20)
		screenOutput.y = 720 - 144 - 20;
	}

void Student::Update(char R) {
	switch (moving) {
		case 'E':
			screenOutput.x += 5;
			if((spriteCount%10) == 0)
				sheetOrgin.x = (4 * 96) + (spriteCount/10 * 96);
			sheetOrgin.y = 144;
			break;
		case 'W':
			screenOutput.x -= 5;
			if ((spriteCount % 10) == 0)
				sheetOrgin.x = (spriteCount/10 * 96);
			sheetOrgin.y = 144;
			break;
		case 'N':
			screenOutput.y -= 5;
			if ((spriteCount % 10) == 0)
				sheetOrgin.x = (4 * 96) + (spriteCount/10 * 96);
			sheetOrgin.y = 0;
			break;
		case 'S':
			screenOutput.y += 5;
			if ((spriteCount % 10) == 0)
				sheetOrgin.x = (spriteCount/10 * 96);
			sheetOrgin.y = 0;
			break;
		default:
			sheetOrgin.x = 0;
			sheetOrgin.y = 0;
			break;
	}
	if (moving != '-') {
		spriteCount += 2;
	}
	if (spriteCount > 39)
		spriteCount = 0;
	if (immune > 0)
		immune--;
	
	// check wall col based on room
	switch (R) {
		case '1': WallDetection(false, true, false, false); break;
		case '2': WallDetection(false, true, false, true); break;
		case '3': WallDetection(false, false, false, true); break;
	}
}

Student::~Student()
{

}
